-- *** how to stop engine trees from spawning?

function gadget:GetInfo()
  return {
    name      = "feature spawner",
    desc      = "spawn features on the map, as defined in a config file",
    author    = "knorke",
    date      = "May 2011",
    license   = "GNU GPL, v2 or later or horse",
    layer     = 0,
    enabled   = true,  --  loaded by default?
  }
end


if not gadgetHandler:IsSyncedCode() then
  return false -- no unsynced code
end

local GetGaiaTeamID = Spring.GetGaiaTeamID()
local mapfeatures = {}
local pelletsn = 1
function pellet (x,y,z)
	pelletsn=pelletsn+1
	mapfeatures[pelletsn] = {}
	--mapfeatures[pelletsn].name = "tppellet_1"
	mapfeatures[pelletsn].x = x
	mapfeatures[pelletsn].y=y
	mapfeatures[pelletsn].z=z
end



pellet (280 , 71 , 3864)
pellet (600 , 72 , 3864)
pellet (920 , 73 , 3864)
pellet (1240 , 73 , 3864)
pellet (1560 , 73 , 3864)
pellet (1880 , 70 , 3864)
pellet (2200 , 71 , 3880)
pellet (2520 , 72 , 3880)
pellet (2840 , 73 , 3880)
pellet (3160 , 73 , 3880)
pellet (3480 , 73 , 3880)
pellet (3800 , 73 , 3880)
pellet (3816 , 72 , 3528)
pellet (3496 , 73 , 3512)
pellet (3176 , 71 , 3496)
pellet (264 , 72 , 3512)
pellet (584 , 71 , 3496)
pellet (904 , 72 , 3480)
pellet (1416 , 71 , 3464)
pellet (1832 , 73 , 3480)
pellet (2248 , 72 , 3496)
pellet (2664 , 73 , 3480)
pellet (3144 , 72 , 3096)
pellet (2824 , 71 , 3096)
pellet (2504 , 72 , 3096)
pellet (2184 , 71 , 3096)
pellet (1864 , 72 , 3112)
pellet (1544 , 71 , 3112)
pellet (1224 , 70 , 3112)
pellet (904 , 74 , 3112)
pellet (264 , 71 , 2760)
pellet (584 , 73 , 2760)
pellet (904 , 73 , 2760)
pellet (1224 , 72 , 2744)
pellet (1544 , 74 , 2744)
pellet (1864 , 73 , 2744)
pellet (2216 , 73 , 2744)
pellet (2536 , 72 , 2744)
pellet (2856 , 73 , 2744)
pellet (3176 , 72 , 2760)
pellet (3496 , 74 , 2760)
pellet (3816 , 72 , 2760)
pellet (1384 , 70 , 2328)
pellet (1704 , 71 , 2328)
pellet (2024 , 72 , 2328)
pellet (2344 , 72 , 2328)
pellet (2664 , 70 , 2328)
pellet (1400 , 72 , 1560)
pellet (1720 , 71 , 1560)
pellet (2040 , 70 , 1560)
pellet (2360 , 71 , 1560)
pellet (2680 , 73 , 1560)
pellet (1384 , 71 , 1944)
pellet (2664 , 70 , 1928)
pellet (984 , 71 , 2456)
pellet (984 , 71 , 2136)
pellet (984 , 70 , 1816)
pellet (984 , 71 , 1496)
pellet (984 , 71 , 1176)
pellet (984 , 70 , 856)
pellet (984 , 70 , 536)
pellet (984 , 71 , 216)
pellet (3112 , 71 , 2440)
pellet (3128 , 71 , 2120)
pellet (3128 , 71 , 1800)
pellet (3144 , 72 , 1480)
pellet (3144 , 70 , 1160)
pellet (3160 , 71 , 840)
pellet (3176 , 73 , 520)
pellet (3176 , 72 , 200)
pellet (1240 , 71 , 760)
pellet (1560 , 72 , 760)
pellet (1880 , 71 , 760)
pellet (2200 , 72 , 760)
pellet (2520 , 72 , 760)
pellet (2840 , 72 , 760)
pellet (1320 , 72 , 232)
pellet (1784 , 73 , 232)
pellet (2280 , 72 , 264)
pellet (2776 , 72 , 232)
pellet (296 , 71 , 1144)
pellet (264 , 72 , 248)
pellet (632 , 72 , 760)
pellet (632 , 72 , 1144)
pellet (3816 , 72 , 1144)
pellet (3816 , 73 , 248)
pellet (3496 , 72 , 1176)
pellet (3480 , 72 , 776)
pellet (2696 , 73 , 1144)
pellet (2264 , 71 , 1192)
pellet (1848 , 73 , 1176)
pellet (1416 , 72 , 1160)
pellet (264 , 71 , 3096)
pellet (3832 , 74 , 3128)


pellet_name = "tppellet_2"
always_vis = true
local function PutFeaturesOnMap ()
	if (mapfeatures == nil) then return end	
	Spring.Echo ("tp_feature_spawn.lua: ----PutFeaturesOnMap ()----")
	if (mapfeatures) then
		Spring.Echo ("#mapfeatures:" .. table.getn(mapfeatures))
		for i in pairs(mapfeatures) do			
			--Spring.Echo ("PutFeaturesOnMap:" .. i)
			--Spring.Echo ("PutFeaturesOnMap:" .. mapfeatures[i].x .. ":" .. mapfeatures[i].z)
			local y = Spring.GetGroundHeight (mapfeatures[i].x, mapfeatures[i].z)
			local fid = Spring.CreateFeature (pellet_name,  mapfeatures[i].x, y, mapfeatures[i].z, mapfeatures[i].rot or math.random (0,32000), GetGaiaTeamID)			
			if (fid) then Spring.SetFeatureAlwaysVisible (fid, always_vis) end
		end
	end
end

function RemoveFeatures ()
	local all_features = Spring.GetAllFeatures ()
	for i in pairs(all_features) do		
		Spring.DestroyFeature (all_features[i])
	end
end


	
function gadget:Initialize()
	if (Spring.GetMapOptions~=nil) then
		local pellet_metal = Spring.GetMapOptions()["pellet_metal"] or 1
		
		if (pellet_metal == '0') then pellet_name = "tppellet_1" end
		if (pellet_metal == '1') then pellet_name = "tppellet_2" end
		if (pellet_metal == '2') then pellet_name = "tppellet_3" end
		if (pellet_metal == '3') then pellet_name = "tppellet_4" end
		Spring.Echo ("pellet: " .. pellet_name)
		local mo_always_vis = Spring.GetMapOptions()["always_vis"] or 1
		if (mo_always_vis == '0') then always_vis = false end
		if (mo_always_vis == '1') then always_vis = true end
	end
	PutFeaturesOnMap ()
	gadgetHandler:RemoveGadget()
end