function gadget:GetInfo()
  return {
    name      = "wraparound map",
    desc      = "teleport units from one map edge to another",
    author    = "knorke",
    date      = "Nov 2010",
    license   = "GNU GPL, v2 or later or horse",
    layer     = 0,
    enabled   = true,
  }
end

local movecrtlunits = {}
local debug = false

if not gadgetHandler:IsSyncedCode() then
  return false -- no unsynced code
end

local exitmoveaway = 500	--how much further away from the exit will units move away?


local teleport = {}
teleport[1] = {}
teleport[1].x1=5		--4 corners to define a rectangle area
teleport[1].z1=1800		--NOTE: x1 & z1 should be the smaller coordinate numbers because corner order is used to
teleport[1].x2=450		--give units a waypoint after exiting the teleport
teleport[1].z2=2040
teleport[1].name = "left tunnel"
teleport[1].entrydir = "left" 	-- left | right 	TODO: up | down | any | exitonly
teleport[1].exitid = 2  	  	--units entering this teleport will teleport to the teleport with this id
teleport[1].exitdir = "right"	--units that exit here, will move to the middle of this side of the rectangle area

teleport[2] = {}
teleport[2].x1=3700
teleport[2].z1=1800
teleport[2].x2=4080
teleport[2].z2=2040
teleport[2].name = "right tunnel"
teleport[2].entrydir = "right"
teleport[2].exitid = 1
teleport[2].exitdir = "left"

function gadget:GameStart()

end

function gadget:GameFrame(frame)
--Spring.Echo ("hey!")
	if (frame%30 == 0) then
		if (debug) then Spring.Echo ("checking for units in area") end
		for ti = 1, #teleport, 1 do
			units = Spring.GetUnitsInRectangle (teleport[ti].x1, teleport[ti].z1, teleport[ti].x2, teleport[ti].z2)
			--if (not units) then Spring.Echo ("keiner da") return end
			--if (#units >0) then Spring.Echo ("#units=" .. #units) end
			for i in pairs(units) do
				if Spring.ValidUnitID (units[i]) then
					local dx, dy,dz = Spring.GetUnitDirection (units[i])
					local ed = teleport[ti].entrydir
					if (ed == "left" and dx < 0) 
					or (ed == "right" and dx > 0)
						then
						if (debug) then marker_on_unit (units[i], "in area " .. teleport[ti].name) end
						local x,y,z=Spring.GetUnitPosition (units[i])
						if (x and y and z) then Spring.SpawnCEG ("tpteleportdepart", x, 100,z) end
						teleport_unit_in_area (units[i], teleport[ti].exitid)
					end
				end
			end
		end
	end

	if ((frame+1)%2 == 0) then
	for ui in pairs(movecrtlunits) do
		--Spring.Echo ("unmoving: " .. ui)
		--Spring.MoveCtrl.Disable(ui)
		movecrtlunits[ui] = nil
		--Spring.GiveOrderToUnit(ui, CMD.MOVE , {2000, 100, 2000  }, {})
		
--		local unitCommands = Spring.GetUnitCommands(ui)   --does not work
--		if #unitCommands > 0 then
--			Spring.GiveOrderToUnit(ui, unitCommands)
--		end
   end




	end
end



function gadget:Initialize()
	Spring.Echo ("tp_wraparoundmap: yeaah here i am!")
	if (not debug) then return end
	for i = 1, #teleport, 1 do
		Spring.Echo ("marking teleport #" .. i)
		Spring.MarkerAddPoint (teleport[i].x1,100, teleport[i].z1, teleport[i].name)
		Spring.MarkerAddPoint (teleport[i].x2,100, teleport[i].z2, teleport[i].name)
		Spring.MarkerAddPoint (teleport[i].x1,100, teleport[i].z2, teleport[i].name)
		Spring.MarkerAddPoint (teleport[i].x2,100, teleport[i].z1, teleport[i].name)
	end
end


function teleport_unit_in_area (ui, ti)
	local x = math.random (teleport[ti].x1, teleport[ti].x2)
	local z = math.random (teleport[ti].z1, teleport[ti].z2)
	Spring.MoveCtrl.Enable(ui)
	Spring.MoveCtrl.SetPosition (ui,x,100,z)
	Spring.SpawnCEG ("tpteleportarrive", x, 100,z)
	Spring.MoveCtrl.Disable(ui)
	movecrtlunits [ui] = true
	local mtx, mtz	--movetartget (x,z) where should the unit move to after exiting the teleport?
	local ed = teleport[ti].exitdir
	if (ed=="left") then mtx = teleport[ti].x1-exitmoveaway mtz = (teleport[ti].z1+teleport[ti].z2)/2 end
	if (ed=="right") then mtx = teleport[ti].x2+exitmoveaway mtz = (teleport[ti].z1+teleport[ti].z2)/2 end
	if (debug) then Spring.MarkerAddPoint (mtx,100,mtz, "move target:" .. mtx ..":"..mtz) end
	Spring.GiveOrderToUnit(ui, CMD.MOVE , {mtx, 100, mtz}, {})
end

function marker_on_unit (_uID, _text)
	if (not debug) then return end
	if (markers == false) then return end
	if (_uID == nil) then return end
	if (_text == nil) then return end
	local x,y,z=Spring.GetUnitPosition (_uID)
	if (x == nil or y == nil or z == nil) then return end
	Spring.MarkerAddPoint (x,y,z, _text .. "id:" .. _uID)
end